#ifdef __cplusplus
#include <cstdlib>
#else
#include <stdlib.h>
#endif

#include "res.h"


bool done = false;
int32_t tt=10;

int gamethread(void *data);
bool gameend=false;
SDL_Thread *sys;

int main ( int argc, char** argv )
{

    srand(time(NULL));
    // initialize SDL video
    if ( SDL_Init( SDL_INIT_VIDEO | SDL_INIT_AUDIO ) < 0 )
    {
        printf( "Unable to init SDL: %s\n", SDL_GetError() );
        return 1;
    }

    SDL_EnableKeyRepeat(50,SDL_DEFAULT_REPEAT_INTERVAL);

    // make sure SDL cleans up before exit
    atexit(SDL_Quit);



    //SDL_Surface* screen = SDL_SetVideoMode(screen_w, screen_h, 32,SDL_HWSURFACE|SDL_DOUBLEBUF);
#ifdef DINGOO
    SDL_ShowCursor(SDL_DISABLE);
    SDL_Surface* screen = SDL_SetVideoMode(screen_w, screen_h, 16,SDL_SWSURFACE);
#else
    SDL_Surface* screen = SDL_SetVideoMode(screen_w, screen_h, 32,SDL_SWSURFACE);
#endif



    if ( !screen )
    {
        printf("Unable to set 320x240 video: %s\n", SDL_GetError());
        return 1;
    }


    Load_Game_Resources(screen);



    ClearPole();
    FlushCards();


    Mix_Music *music = NULL;


    int audio_rate = 44100;
    Uint16 audio_format = AUDIO_S16; /* 16-bit stereo */
    int audio_channels = 2;
    int audio_buffers = 8192;

    Mix_OpenAudio(audio_rate, audio_format, audio_channels, audio_buffers);

    music=Mix_LoadMUS("./TetraMaster.wav");

    if (music)
        Mix_PlayMusic(music,0);

    // program main loop
    Kii=0;
    sys=SDL_CreateThread(gamethread,screen);

    while (!done)
    {
        // message processing loop
        Kii=0;

        SDL_Event event;
        while (SDL_PollEvent(&event))
        {
            // check for messages
            switch (event.type)
            {
                // exit if the window is closed
            case SDL_QUIT:
                done =  true;
                gameend = true;
                break;

                // check for keypresses
            case SDL_KEYDOWN:
            {
                Kii=event.key.keysym.sym;
            }
            // case SDL_KEYUP:
            // {
            //     Kii=event.key.keysym.sym;
            // }
            } // end switch
            //
        } // end of message processing
#ifdef DINGOO
        SDL_Delay(150);
#else
        SDL_Delay(100);
#endif

    } // end main loop
    if (sys) SDL_KillThread(sys);
    Mix_CloseAudio();
    return 0;
}


int gamethread(void *data)
{
    SDL_Surface *scr;
    scr=(SDL_Surface *)data;

    uint32_t fps,fpsshow,fpstimer=0;
    fpstimer=0;

    while (!gameend)
    {

        fps++;

        if (fpstimer<=millisec())
        {
            fpsshow=fps;
            fps=0;
            fpstimer=millisec()+1000;
        };

        char pss[10];
        memset(pss,0,10);
        sprintf(pss,"%d",fpsshow);


        Global_Draw_Game_scrn(scr);


        TextFF(10,10,pss,scr);




        if (input_GetState(Ki_START))
        {
            Init_Game(scr);
        }

        if (input_GetState(Ki_SELECT))
        {
            done = true;
            gameend = true;
        };

        SDL_Flip(scr);
#ifdef DINGOO
        SDL_Delay(2*fpsmul);
#else
        SDL_Delay(1000/50);
#endif

    }
    sys=NULL;
    return 0;
}
